import string

## 1. Open the file "LeavesOfGrass.txt"
with open('../python_class/LeavesOfGrass.txt','r') as f:
	read_data = f.read()

## 2. Split the file into word list (lower-case) and print out the first 25 words on the list

## 2.1 Simply use string.split() -- with punctuation attached
wordList_w_punc = read_data.lower().strip().split()
print wordList_w_punc[0:25]

## 2.2 Use "for loop" to remove punctuations in the original text
tmp=''
for o in read_data.strip().lower():
	if o not in string.punctuation:
		tmp += o
wordList_wo_punc = tmp.split()
print wordList_wo_punc[0:25]

## *2.3 Use list comprehension to achieve the same result as in 2.2
# wordList_wo_punc2 = ''.join([o for o in read_data.lower() if not o in string.punctuation]).split()
# print wordList_wo_punc2[0:25]

## 3. Count number of times word "grass" occur in the list

## 3.1 Use a "for loop" and a counter
c_grass = 0
for w in wordList_wo_punc:
	if w=='grass':
		c_grass+=1
print 'Word \'grass\' appears {} times in the document'.format(c_grass)

## 3.2 Use list.count() function
print 'Word \'grass\' appears {} times in the document'.format(wordList_wo_punc.count('grass'))


## 4. Count the number of occurrence of each word in the file and save the result to "count_LeavesOfGrass.txt"
dict_wordCount = {}
for w in wordList_wo_punc:
	dict_wordCount[w] = dict_wordCount.get(w,0) + 1

with open('count_LeavesOfGrass.txt','w') as f:
	for word, count in dict_wordCount.iteritems():
		f.write("{}\t{}\n".format(word,count))

## * check the Counter data structure from collections
# from collections import Counter
# print dict([(k,v) for k,v in Counter(wordList_wo_punc).iteritems()])

## 5. Homework part 1: sort the dictionary and save the output to a file

## use operator module
# import operator
# sorted_dict = dict(sorted(dict_wordCount.iteritems(),key=operator.itemgetter(1),reverse=True))

## use lambda function to sort 
sorted_list = sorted(dict_wordCount.iteritems(),key=lambda x: x[1], reverse=True)
with open('sortedCount_LeavesOfGrass.txt','w') as f:
	for wcPair in sorted_list:
		f.write("{}\t{}\n".format(wcPair[0],wcPair[1]))

